import java.awt.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;


// ----------------------------------------------------
//     Hilo de Comunica
// ----------------------------------------------------
class Comunica extends Thread
{
  Proceso p;
  Comunica(Proceso p1) { p=p1; }
  public void run()
  {
     while (true)
       {
         for (int id=3001;id<3006;id++)
          {
           if (id!=p.id)
             {
              try {
                    if (p.ide[id-3001])
                    {
                    Socket s=new Socket("127.0.0.1",id);
                    DataInputStream i=new DataInputStream(s.getInputStream());
                    DataOutputStream o=new DataOutputStream(s.getOutputStream());
                    o.writeBytes(""+(p.id-3001)+"\r\n");
                    o.writeBytes(""+(p.x)+"\r\n");
                    o.writeBytes(""+(p.y)+"\r\n");
                    s.close();
                    }
                  } catch(Exception e) { p.ide[id-3001]=false; }
             }
           try { sleep(10); } catch(Exception e) { }
          }
       }
  }
}
// ----------------------------------------------------
//     Hilo de Atiende Servidor
// ----------------------------------------------------
class Atiende extends Thread
{
  Proceso p; Socket s;
  Atiende(Socket s1,Proceso p1) { s=s1; p=p1; }
  public void run()
  {
    try
    {
     DataInputStream i=new DataInputStream(s.getInputStream());
     DataOutputStream o=new DataOutputStream(s.getOutputStream());
     String id=i.readLine();
     String cx=i.readLine();
     String cy=i.readLine();
     p.cx[Integer.valueOf(id).intValue()]=Integer.valueOf(cx).intValue();
     p.cy[Integer.valueOf(id).intValue()]=Integer.valueOf(cy).intValue();
     p.ide[Integer.valueOf(id).intValue()]=true;
     s.close();
    } catch(Exception e) { }
  }
}
// ----------------------------------------------------
//     Hilo de Servidor
// ----------------------------------------------------
class Servidor extends Thread
{
  Proceso p;
  Servidor(Proceso p1) { p=p1; }
  public void run()
  {
    try
    {
     ServerSocket ss=new ServerSocket(p.id);
     while (true)
      {
        Socket s=ss.accept();
        new Atiende(s,p).start();
      }
    } catch(Exception e) { }
  }
}
// ----------------------------------------------------
//     Hilo de Proceso General
// ----------------------------------------------------
class Proceso extends Thread
{
  public int[] cx;
  public int[] cy;
  public int[] cxa;
  public int[] cya;
  public boolean[] ide;
  public int id,x,y,kx,ky;
  P3Xnnnnnn w;
  Proceso()
  {
   w=null;
   ide=new boolean[7];
   cx=new int[7];
   cy=new int[7];
   cxa=new int[7];
   cya=new int[7];
   for (int k=0;k<7;k++) { ide[k]=true; cx[k]=-1; cy[k]=-1; cxa[k]=-1; cya[k]=-1; }
   id=3001;
        try
        {
          while (true)
          {
           Socket exp=new Socket("127.0.0.1",id);
           exp.close();
           id++; if (id==3006) System.exit(0);
          }
        } catch(Exception e){ }
   new Comunica(this).start();
   new Servidor(this).start();
   x=(int)(30+Math.random()*100);
   y=(int)(30+Math.random()*100);
   kx=2; ky=2;
  }
  public void setWindow(P3Xnnnnnn w1) { w=w1; }
  public void run()
  {
    while(true)
    {
      if (w!=null)
         {
          Graphics g=w.getGraphics();
          g.setColor(Color.white);
          g.fillOval(x-5,y-5,10,10);
          if (id==3001) g.setColor(Color.blue);
          if (id==3002) g.setColor(Color.green);
          if (id==3003) g.setColor(Color.red);
          if (id==3004) g.setColor(Color.yellow);
          if (id==3005) g.setColor(Color.orange);
          x+=kx; if ((x<2)||(x>320)) kx=-kx;
          y+=ky; if ((y<2)||(y>240)) ky=-ky;
          g.fillOval(x-5,y-5,10,10);
          for (int k=0;k<7;k++)
             {
               int k1=k+1;
               if ((cx[k]>=0)&&(cy[k]>=0))
                 {
                  g.setColor(Color.white);
                  if ((cxa[k]>=0)&&(cya[k]>=0))
                  g.fillOval(cxa[k]-5,cya[k]-5,10,10);
                  if (k1==1) g.setColor(Color.blue);
                  if (k1==2) g.setColor(Color.green);
                  if (k1==3) g.setColor(Color.red);
                  if (k1==4) g.setColor(Color.yellow);
                  if (k1==5) g.setColor(Color.orange);
                  cxa[k]=cx[k];cya[k]=cy[k];
                  g.fillOval(cx[k]-5,cy[k]-5,10,10);
                 }
             }
          try { sleep(50); } catch(Exception e) { }
         } else
          try { sleep(1000); } catch(Exception e) { }
    }
  }

}

// ----------------------------------------------------
public class P3Xnnnnnn extends Frame
{
  Proceso p;
  P3Xnnnnnn()
   { super();
     p=new Proceso();
     p.start();
     String t="Prctica 3:   ";
          if (p.id==3001) t=t+"1-Azul";
          if (p.id==3002) t=t+"2-Verde";
          if (p.id==3003) t=t+"3-Rojo";
          if (p.id==3004) t=t+"4-Amarillo";
          if (p.id==3005) t=t+"5-Naranja";
     setTitle(t);
   }

  public static void main(String args[])
  {
   P3Xnnnnnn w=new P3Xnnnnnn();
   w.setSize(320,240); w.setResizable(false);
   w.show();
  }

  public void paint(Graphics g)
   {
     p.setWindow(this);
   }

  public boolean mouseDown(Event evt,int x,int y)
   {
      return super.mouseDown(evt,x,y);
   }

  public boolean action (Event e, Object o)
  {
   return super.action(e,o);
  }

  public boolean handleEvent (Event e)
  {
   if (e.id==Event.WINDOW_DESTROY)  System.exit (0);
   return super.handleEvent(e);
  }

}
