// -------------------------------------------------
// -------------------------------------------------
//   Demo Servidor Web
// -------------------------------------------------
// -------------------------------------------------
import java.io.*;
import java.awt.*;
import java.net.*;
import java.util.*;
import java.lang.Math;
import java.lang.Float;

class Proceso extends Thread
{
  Datos d;
  Proceso(Datos d1) { d=d1; }
  public void run()
  { d.c--;
    while(true)
    {
    try { sleep(1000);  } catch (Exception e) { }
    try {
          Socket s=new Socket("localhost",3010);
          DataInputStream In;
          In  = new DataInputStream(s.getInputStream());
          String hora=In.readLine();
          d.hora=hora;
        } catch (Exception e) { }

    }
  }
}

class Datos
{
  int c=10;
  String hora;
  Datos() { c=0; hora=""; }
}

// -------------------------------------------------
//   BrowserAnswer
//   Hilo que atiende a cada Browser
// -------------------------------------------------
class BrowserAnswer extends Thread
{int i,j;
   Socket s; Datos d;
   BrowserAnswer( Socket s1, Datos d1 ) { s=s1; d=d1; }
   public void run()
   {
    d.c++;
    try {
      DataInputStream In;
      DataOutputStream  Out;
      In  = new DataInputStream(s.getInputStream());
      Out = new DataOutputStream(s.getOutputStream());

//--------------------------------------------
//    El Arreglo commands que va desde
//    commands[0] .. commands[commands.length-1]
//    contiene todo lo que el browser ha enviado.
//    Se envia a la consola para depuracin
//--------------------------------------------
      String[] commands = readCommands(In);
      for (int t=0;t<commands.length;t++)
      System.out.println( commands[t] );
      System.out.println( " ----------------------------------- " );
      System.out.println( commands[0] );
      System.out.println( " ----------------------------------- " );
//--------------------------------------------

//--------------------------------------------
//    Construccin de la Pgina
//--------------------------------------------
      String Pagina="<HTML>";
      Pagina+="<TITLE>Sorteo</TITLE>";
      	 i = commands[0].indexOf("Text1=");
      	 if (i > -1)
      //if (commands[0].indexOf("/uno?")>=0)
         {// i = commands[0].indexOf("Text1=");
			 j = commands[0].indexOf("&Text2");
			 String x = commands[0].substring(i+6, j);

			 i = commands[0].indexOf("Text2=");
			 j = commands[0].indexOf("&Select1");
			 String y = commands[0].substring(i+6, j);
			 i = commands[0].indexOf("Select1=");
			 j = commands[0].indexOf("HTTP");
			 String operador = commands[0].substring(i+8, j);
			 Float Xa = Float.valueOf(x);
			 Float Ya = Float.valueOf(y);
			 float n1 = Xa.floatValue();
			 float n2 = Ya.floatValue();
			 float Res=0;
			 if (operador.equals("- "))
			   Res = (n1-n2);
			 if (operador.equals("* "))
			   Res = n1*n2;
			 if (operador.equals("%2F "))
			 {operador="/";
			   Res = n1/n2;
		     }
			 if (operador.equals("%2B "))
			 { operador="+";
			   Res = n1+n2;
		     }
		      if (operador.equals("%25 "))
			 { operador="%";
			   Res = ((n2*100)/n1);
		     }
		     if (operador.equals("sin%28X%29 "))
			 { operador="sin(X)";
			   Res = ((n2*100)/n1);
		     }
		     if (operador.equals("cos%28X%29 "))
			 { operador="cos(X)";
			   Res = ((n2*100)/n1);
		     }
		     if (operador.equals("tan%28X%29 "))
			 { operador="tan(X)";
			   Res = (n2/n1);
		     }
Pagina+=operador;

			 Pagina+="<FORM><P>X:<INPUT TYPE=TEXT NAME=Text1 Value="+x+"></P>";
			 Pagina+="<P>Y:<INPUT TYPE=TEXT NAME=Text2 Value="+y+"></P>";
			 Pagina+="<P>=======================<SELECT NAME=Select1 SIZE=1 ><OPTION selected>"+operador+"</OPTION><OPTION>+</OPTION>";
			 Pagina+="<OPTION>-</OPTION> <OPTION>*</OPTION> <OPTION>/</OPTION> <OPTION>%</OPTION>";
			 Pagina+="<OPTION>sin(X)</OPTION> <OPTION>cos(X)</OPTION> <OPTION>tan(X)</OPTION></SELECT>";
			 Pagina+="<INPUT TYPE=SUBMIT VALUE=Calcula>";
			 Pagina+="<P>R:<INPUT TYPE=TEXT NAME=Text3 Value="+Res+"></P></P></FORM>";





         } else
      {
      Pagina+="<META HTTP-EQUIV=Refresh";
      Pagina+=" CONTENT=200;URL=.>";
      Pagina+="<FORM ACTION=/uno METHOD=GET>";
     Pagina+="<P>X:<INPUT TYPE=TEXT NAME=Text1></P>";
	 Pagina+="<P>Y:<INPUT TYPE=TEXT NAME=Text2></P>";
	 Pagina+="<P>=======================<SELECT NAME=Select1 SIZE=1> <OPTION>+</OPTION>";
	 Pagina+="<OPTION>-</OPTION> <OPTION>*</OPTION> <OPTION>/</OPTION> <OPTION>%</OPTION><OPTION>sin(X)</OPTION> <OPTION>cos(X)</OPTION> <OPTION>tan(X)</OPTION>";
	 Pagina+="</SELECT><INPUT TYPE=SUBMIT VALUE=Calcula></P></FORM></BODY>";
      }
      Pagina+="</HTML>";
//--------------------------------------------
//    Respuesta necesaria de cabecera para el Browser
//--------------------------------------------
      Out.writeBytes("HTTP/0.1 200 OK\r\n");
      Out.writeBytes("Server: MiniWeb 0.1\r\n");
      Out.writeBytes("MIME-Version: 1.0\r\n");
      Out.writeBytes("Content-type: text/html \r\n");
      Out.writeBytes("Content-length: "+Pagina.length()+" \r\n");
      Out.writeBytes("\r\n");
//--------------------------------------------
//    Envio de Pgina HTML al Browser
//--------------------------------------------
      Out.writeBytes(Pagina);

//--------------------------------------------
//    Cierre de Socket con Browser
//--------------------------------------------
      sleep(1000);
      s.close();
//--------------------------------------------
        } catch(Exception e) { }

   }


// -------------------------------------------------
//   readCommands
//   Este mtodo lee todo lo que el Browser envia
// -------------------------------------------------
 private String[] readCommands(InputStream in)
 {
  try
  {
   Vector lines= new Vector();
   Vector vector = new Vector(100);
   int dataLength = 0;
   boolean done = false;
   Character CR = new Character('\r');
   Character LF = new Character('\n');
   int c, oldc=0;
   while (!done)
   {
    Thread.yield();
    c = in.read();
    if (c == -1) stop();
    else
    {
     vector.addElement(new Character((char)c));
     dataLength++;
     if (dataLength>=4)
      done = (((Character)vector.elementAt(dataLength-4)).equals(CR)) &&
       (((Character)vector.elementAt(dataLength-3)).equals(LF))  &&
       (((Character)vector.elementAt(dataLength-2)).equals(CR))  &&
       (((Character)vector.elementAt(dataLength-1)).equals(LF)) ;
    }
   }
   char[] charArray = new char[dataLength];
   for (int n=dataLength-1; n>=0;n--)
    charArray[n] = ((Character)vector.elementAt(n)).charValue();
   StringTokenizer st = new StringTokenizer(new String(charArray),"\r\n");
   int numOfLines = st.countTokens();
   String[] commands = new String[numOfLines];
   for (int n=numOfLines;n>0;n--)
    commands[numOfLines-n] = st.nextToken();
   return commands;
  }
  catch(Exception e)
  {
   stop();
   String[] result = {""};
   return result;
  }
 }

}
// -------------------------------------------------
// -------------------------------------------------
//   Clase Principal MiniWebServer
// -------------------------------------------------
// -------------------------------------------------
public class Sorteo
{
public static void main(String[] a)
 {
   try
   {
   Datos d=new Datos();
   Proceso p=new Proceso(d);
      p.start();

   ServerSocket ss = new ServerSocket(81);
   while (true)
     {
      Socket s = ss.accept();
      new BrowserAnswer(s,d).start();
      }
    }catch(Exception e){}
 }
}
